// 񕪖@ɂOp֐̌vZ
// https://talavax.com/math-trifunction.html ɂ̂delphiɕϊ܂B

unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    LabeledEdit2: TLabeledEdit;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

function GetOrthant(deg: double): integer;
begin
  result := 0;
  if (0   < deg) and (90  > deg) then result := 1;
  if (90  < deg) and (180 > deg) then result := 2;
  if (180 < deg) and (270 > deg) then result := 3;
  if (270 < deg) and (360 > deg) then result := 4;
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
var
  ch                : integer;
  orthant, loopnumber : integer;
  delta             : extended;
  deg, rad          : extended;
  deg1, deg2, degm  : extended;
  x1, y1            : extended;
  x2, y2            : extended;
  mx, my, d         : extended;
  new_x, new_y      : extended;
  ans_sin, ans_cos, ans_tan : extended;
begin
  val(LabeledEdit1.Text, deg, ch);
  if ch <> 0 then begin
    application.MessageBox('px͒lɊԈႢ܂B','',0);
    exit;
  end;
  val(LabeledEdit2.Text, delta, ch);
  if ch <> 0 then begin
    application.MessageBox('덷͒lɊԈႢ܂B','',0);
    exit;
  end;
  if delta >= 1 then begin
    application.MessageBox('덷̒l͂PȉɂĉB','',0);
    exit;
  end;
  if delta < 0 then begin
    application.MessageBox('덷̒l͂O͂OȏɂĉB','',0);
    exit;
  end;
  if deg < 0 then
    repeat
      deg := deg + 360;
    until deg >= 0;
  if deg >= 360 then
    repeat
      deg := deg - 360;
    until deg < 360;
  ans_sin := 0;
  ans_cos := 0;
  ans_tan := 0;
  loopnumber := 0;
  orthant := GetOrthant(deg);
  x1 := 0;
  y1 := 0;
  x2 := 0;
  y2 := 0;
  deg1 := 0;
  deg2 := 0;
  case orthant of
    1 : begin
          deg1 := 0;
          deg2 := 90;
          x1 := 1;
          y1 := 0;
          x2 := 0;
          y2 := 1;
        end;
    2:  begin
          deg1 := 90;
          deg2 := 180;
          x1 := 0;
          y1 := 1;
          x2 := -1;
          y2 := 0;
        end;
    3:  begin
          deg1 := 180;
          deg2 := 270;
          x1 := -1;
          y1 := 0;
          x2 := 0;
          y2 := -1;
        end;
    4:  begin
          deg1 := 270;
          deg2 := 360;
          x1 := 0;
          y1 := -1;
          x2 := 1;
          y2 := 0;
        end;
  end;
  if orthant = 0 then begin
    if 0 = deg then begin
      ans_sin := 0;
      ans_cos := 1;
      ans_tan := 0;
    end;
    if 90 = deg then begin
      ans_sin := 1;
      ans_cos := 0;
      ans_tan := infinity;
    end;
    if 180 = deg then begin
      ans_sin := 0;
      ans_cos := -1;
      ans_tan := 0;
    end;
    if 270 = deg then begin
      ans_sin := -1;
      ans_cos := 0;
      ans_tan := -infinity;
    end;
  end;
  if orthant > 0 then begin
    repeat
      inc(loopnumber);
      degm := (deg1 + deg2) / 2;              // Ԃ̊px
      mx := (x1 + x2) / 2;
      my := (y1 + y2) / 2;
      d := sqrt(mx * mx + my * my);
      new_x := mx / d;                        // ԍWX
      new_y := my / d;                        // ԍWy
      if deg > degm then begin                // wpx>Ԃ̊px
        x1 := new_x;                            // x1 = ԍWX
        y1 := new_y;                            // y1 = ԍWy
        deg1 := degm;                           // deg1 = Ԃ̊px
      end
      else begin                              // wpx<Ԃ̊px
        x2 := new_x;                            // x2 = ԍWX
        y2 := new_y;                            // y2 = ԍWy
        deg2 := degm;                           // deg2 = Ԃ̊px
      end;
    until abs(degm - deg) <= delta;
    ans_sin := new_y;
    ans_cos := new_x;
    ans_tan := ans_sin / ans_cos;
  end;
  memo1.Clear;
  memo1.Lines.Append('񕪖@ɂvZ');
  memo1.Lines.Append('loop = ' + intTostr(loopnumber));
  memo1.Lines.Append('sin(' + floatTostr(deg) + ')= ' + floatTostr(ans_sin));
  memo1.Lines.Append('cos(' + floatTostr(deg) + ')= ' + floatTostr(ans_cos));
  memo1.Lines.Append('tan(' + floatTostr(deg) + ')= ' + floatTostr(ans_tan));
  memo1.Lines.Append('');
  memo1.Lines.Append('MathɂvZ');
  rad := deg / 180 * pi;
  memo1.Lines.Append('sin(' + floatTostr(deg) + ')= ' + floatTostr(sin(rad)));
  memo1.Lines.Append('cos(' + floatTostr(deg) + ')= ' + floatTostr(cos(rad)));
  memo1.Lines.Append('tan(' + floatTostr(deg) + ')= ' + floatTostr(tan(rad)));
end;

end.
